=== debian/changelog ===
opencpn (5.0.0+dfsg-1) unstable; urgency=medium

  [ Alec Leamas ]
  * New upstream release
  * Move to gtk3
    (closes: #946018)
  * Drop all patches besides two after being upstreamed
  * Drop some lintian overrides after upstream fixes.
  * Add a patch for broken include paths.
  * Add a patch for broken FIND_WXWIDGETS in CMakeLists
  * Disable assertion messages using the standard NDEBUG flag.
  * Move appstream data to new location, relicense
    and clean up rules.
  * Bump Standards-Version to 4.4.1, no changes.
  * Move to compat level 12, use new compat scheme
  * Drop dfsg.N suffix to reflect local habits.
  * Move around some docs.

  [ Bas Couwenberg ]
  * Restructure control file with cme.
  * Change libgtk2.0-dev build dependency to libgtk-3-dev.
  * Update watch file to handle common issues.
  * Rename install file to opencpn.install.
  * Drop obsolete include-binaries file.
  * Fix typo in lintian override comment.
  * Drop Name field from upstream metadata.

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 19 Nov 2019 08:49:56 -0500

opencpn (4.8.8+dfsg.2-1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Update gbp.conf to use --source-only-changes by default.
  * Bump Standards-Version to 4.4.0, no changes.
  * Update gbp.conf to source-only uploads

  [ Alec Leamas ]
  * Drop minified js in source instead of binary packages =>
    new  source repacking.
  * Update get-orig-source to fetch actual version, not latest.
  * Relicense appdata.xml to match overall GPL-2+ license.


 -- Alec Leamas <leamas.alec@gmail.com>  Thu, 25 Jul 2019 10:17:35 -0400

opencpn (4.8.8+dfsg.1-1) unstable; urgency=medium

  * Initial upload (closes: #907065, closes: #538067).

 -- Alec Leamas <leamas.alec@gmail.com>  Mon, 21 Jan 2019 13:03:28 -0400
