=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\.?\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;,\
filenamemangle=s/(?:.*?\/)?(?:rel|v|opencpn)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/opencpn-$1.$2/,\
repacksuffix=+dfsg \
https://github.com/OpenCPN/OpenCPN/releases \
(?:.*?/archive/)?(?:rel|v|opencpn)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
